<id>
Board Post Modify Limit for YaBB 2.6.11
</id>

<version>
0.1
</version>

<mod info>
This mod allows admins to set Board-based post modification limits.

Version History
---------------
0.1 - First release - Jan 26, 2015

Instructions:

Apply the mod and upload (in ASCII mode):

cgi-bin/yabb2/Admin/Modlist.pm
cgi-bin/yabb2/Admin/ManageBoards.pm
cgi-bin/yabb2/Languages/English/Admin.lng
cgi-bin/yabb2/Sources/Display.pm
cgi-bin/yabb2/Sources/Load.pm
cgi-bin/yabb2/Sources/Security.pm
</mod info>

<author>
Dandello
</author>

<homepage>
http://www.yabbforumsoftware.com/cgi-bin/yabb2/YaBB.pl
</homepage>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $boardmodtime = q~Board Post Modify Limit|Dandello|This mod allows admins to set Board-based post modification limits.|0.1|01/26/2015~;
    push @installed_mods, $boardmodtime;
</add before>

<edit file>
Admin/ManageBoards.pm
</edit file>

<search for>

        #Get Board permissions here
</search for>

<add before>
        $mod_days_topic = ${ $uid . $editboards[$i] }{'modtopic'} || $tlnomodtime;
</add before>

<search for>
        my $pollperms  = DrawPerms( ${ $uid . $id }{'pollperms'},  0 );
</search for>

<add after>
        my $modperms   = DrawPerms( ${ $uid . $id }{'modtopicperms'},   1 );
</add after>

<search for>
                        <td class="windowbg2"><label for="show$i"><b>$admin_txt{'64e'}</b></label></td>
                        <td class="windowbg2" colspan="3"><input type="checkbox" name="show$i" id="show$i" value="1"$showpriv /> <label for="show$i">$admin_txt{'64f'}</label></td>
                    </tr><tr>
</search for>

<add after>
 ~;
        if ( $tlnomodflag ) {
            $yymain .= qq~                        <td class="windowbg2"><label for="modtopic$i"><b>$admin_txt{'brd_modify_lim'}</b></label></td>
                        <td class="windowbg2" colspan="3"><input type="text" name="modtopic$i" id="modtopic$i" value="$mod_days_topic" size="5" /></td>
                    </tr><tr>
                        <td class="windowbg2"><label for="modtopicperms$i"><b>$admin_txt{'brd_modify_lim_mem'}</b></label></td>
                        <td class="windowbg2" colspan="3"><select multiple="multiple" name="modtopicperms$i" id="modtopicperms$i" size="8">\n$modperms
                            </select>
                        </td>
                    </tr><tr>~;
        }
        $yymain .= qq~
</add after>

<search for>
        );
        ## BRD Mod Hook ##
</search for>

<add before>
            $FORM{"modtopic$i"},
            $FORM{"modtopicperms$i"},
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
1;
</search for>

<add before>
$admin_txt{'brd_modify_lim'} = q~Time limit for specified member groups to modify their posts (in days):<br /><span class="small">Set to 0 to disable the time limit for the specified groups.</span~;
$admin_txt{'brd_modify_lim_mem'} = qq~Member groups allowed modify their posts beyond $tlnomodtime (days):~;

</add before>

<edit file>
Sources/Display.pm
</edit file>

<search for>
            if (
                $sessionvalid == 1
                && (
</search for>

<add before>
            $modtopic_chk = 0;
            if ( $tlnomodflag && ${ $uid . $currentboard }{'modtopic'} ne $tlnomodtime && AccessCheck( $currentboard, 5 ) eq 'granted' ) {
                if ( ${ $uid . $currentboard }{'modtopic'} == 0 || $date < $mdate + ( ${ $uid . $currentboard }{'modtopic'} * 3600 * 24 ) ) {
                    $modtopic_chk = 1;
                }
            }
</add before>

<search for>
                            || $date < $mdate + ( $tlnomodtime * 3600 * 24 ) )
</search for>

<replace>
                           || $date < $mdate + ( $tlnomodtime * 3600 * 24 )
                            || $modtopic_chk == 1
                        )
</replace>

<edit file>
Sources/Load.pm
</edit file>

<search for>
            ## Mod Hook 1 ##
</search for>

<add before>
            $modtopic, $modtopicperms,
</add before>

<search for>
             ## Mod Hook 2 ##
</search for>

<add before>
            'modtopic'      => $modtopic || $tlnomodtime,
            'modtopicperms' => $modtopicperms,
</add before>

<search for>
                $pollperms, $attachperms
</search for>

<replace>
                $pollperms, $attachperms, $modtopicperms
</replace>

<search for>
          "$viewperms|$topicperms|$replyperms|$pollperms|$attachperms";
</search for>

<replace>
          "$viewperms|$topicperms|$replyperms|$pollperms|$attachperms|$modtopicperms";
</replace>

<edit file>
Sources/Security.pm
</edit file>

<search for>
    my ( $viewperms, $topicperms, $replyperms, $pollperms, $attachperms );
</search for>

<replace>
    my ( $viewperms, $topicperms, $replyperms, $pollperms, $attachperms, $modtopicperms );
</replace>

<search for>
        ( $viewperms, $topicperms, $replyperms, $pollperms, $attachperms ) =
</search for>

<replace>
        ( $viewperms, $topicperms, $replyperms, $pollperms, $attachperms, $modtopicperms ) =
</replace>

<search for>
    }
    my $access = 'denied';
</search for>

<add before>
        $modtopicperms = 1;
</add before>

<search for>
    else {                         # Board access check
</search for>

<add before>
    elsif ( $checktype == 5 ) {    # Modtopic access check
        @allowed_groups = split /, /sm, ${ $uid . $curboard }{'modtopicperms'};
        if ( ${ $uid . $curboard }{'modtopicperms'} eq q{} ) { $access = 'granted'; }
        if ( $modtopicperms == 1 && !$topicstart{$username} ) { $access = 'notgranted'; }
    }
</add before>